using System;

namespace Delegates
{
    //
    delegate int CompareItems(Person obj1, Person obj2);
    /// <summary>
	///  Person   name, id, salary, message.
    ///    Person
    ///   .
	/// </summary>
	class Person
	{
        //
        string name;
        int id;
        double salary;
        string message;
        // 
		public Person()
		{name =""; id=0; salary=0.0;}
		public Person(string name)
		{this.name = name;}
		public Person (string name, int id, double salary)
		{ this.name = name; this.id=id; this.salary = salary; }
		public Person (Person pers)
		{
			this.name = pers.name; this.id = pers.id; 
			this.salary = pers.salary;}
            //  
            public string Name
            {
                get { return (name); }
                set { name = value; }
            }
            public double Salary
            {
                get { return (salary); }
                set { salary = value; }
            }
            public int Id
            {
                get { return (id); }
                set { id = value; }
            }
		//
		/// <summary>
		///   
		/// </summary>
		/// <param name="mes"></param>
		/// <returns>   </returns>
        public string ToPerson(string mes)
		{
			this.message = mes;
			return string.Format("{0}, {1}",name, message);
		}
		// 
		private static int CompareName(Person obj1, Person obj2)
		{
			return(string.Compare(obj1.name,obj2.name));
		}
		private static int CompareId(Person obj1, Person obj2)
		{			
            if( obj1.id > obj2.id) return(1);
			else return(-1);
		}
		private static int CompareSalary(Person obj1, Person obj2)
		{			
			if( obj1.salary > obj2.salary) return(1);
			else if(obj1.salary < obj2.salary)return(-1);
			else return(0);
		}
		private static int CompareSalaryName(Person obj1, Person obj2)
		{			
			if( obj1.salary > obj2.salary) return(1);
			else if(obj1.salary < obj2.salary)return(-1);
			else return(string.Compare(obj1.name,obj2.name));
		}
		
		
		//  
		public static CompareItems SortByName
		{
			get	{return(new CompareItems(CompareName));} 
		}
		public static CompareItems SortById
		{
			get	{return(new CompareItems(CompareId));} 
		}
		public static CompareItems SortBySalary
		{
			get	{return(new CompareItems(CompareSalary));} 
		}
		public static CompareItems SortBySalaryName
		{
			get	{return(new CompareItems(CompareSalaryName));} 
		}		
	}//class Person
	
    /// <summary>
    ///   Person
    ///   
    /// </summary>
    class Persons
	{			
		int  n = 100;   // 
        int freeItem;   //   
        private Person[] persons;   // 
        //
        public Persons()
        {
            n = 100; freeItem = 0;
            persons = new Person[n];
        }
        public Persons(int n)
        {
            this.n = n; freeItem = 0;
            persons = new Person[n];
        }

		/// <summary>
		/// . 
        ///      
		/// </summary>
		/// <param name="num"></param>
		/// <returns>   </returns>
		public Person this[int num]
		{
			get { return(persons[num-1]); }
			set { persons[num-1] = value; }
		}
		/// <summary>
		///    
		/// </summary>
		/// <param name="pers"> </param>
		/// <returns>true   </returns>
		public bool AddPerson(Person pers)
		{
			if(freeItem < n)
			{
				Person p = new Person(pers);
				persons[freeItem++]= p;
                return true;
			}
			else return false;			
		}
		/// <summary>
		/// .
        ///    6  
		/// </summary>
        public void LoadPersons()
		{
			//      			
			AddPerson(new Person("",123, 750.0));
			AddPerson(new Person("",128, 850.0));
			AddPerson(new Person("",223, 750.0));			
			AddPerson(new Person("",129, 800.0));
			AddPerson(new Person("",133, 1750.0));
			AddPerson(new Person("",119, 750.0));			
		}//LoadPersons
		/// <summary>
		///    
		/// </summary>
        public void PrintConsolePersons()
		{			
			for(int i =0; i<freeItem; i++)
			{				
				Console.WriteLine("{0,10}  {1,5}  {2,5}",
					persons[i].Name, persons[i].Id, persons[i].Salary);
			}
		}//PrintPersons
		
		/// <summary>
		///    
        ///     compare
		/// </summary>
		/// <param name="compare">   </param>
        public void SimpleSortPerson(CompareItems compare)
		{
			Person temp = new Person();
			for(int i = 1; i<freeItem;i++)
				for(int j = freeItem -1; j>=i; j--)
					if (compare(persons[j],persons[j-1])==-1)
					{
						temp = persons[j-1];
						persons[j-1]=persons[j];
						persons[j] = temp;
					}
		}//SimpleSortObject
	}//Persons
}
