using System;

namespace Delegates
{
    //delegate
    public delegate double DToD(double x);

    /// <summary>
	///  .
    ///   
    ///   
	/// </summary>
	public class HighOrderIntegral
	{
        /// <summary>
        ///     
        /// </summary>
        /// <param name="a">  </param>
        /// <param name="b">  </param>
        /// <param name="eps"> </param>
        /// <param name="sif">  </param>
        /// <returns> </returns>
		public double EvalIntegral(double a, double b, 
			double eps,DToD sif)
		{
            const int INITIAL_POINTS = 4;
            const int MAX_POINTS = 2 << 15;
			int n = INITIAL_POINTS;
			double I0=0, I1 = I( a, b, n,sif);

			for( n *=2; n < MAX_POINTS; n*=2)
			{ 
				I0 =I1; I1=I(a,b,n,sif);
				if(Math.Abs(I1-I0)<eps)break;				
			}
			if(Math.Abs(I1-I0)< eps)
				Console.WriteLine("  ! "+
					" eps = {0},   ={1}, n= {2}",
					eps,Math.Abs(I1-I0),n);
			else
				Console.WriteLine("   ! "+
					" eps = {0},   ={1}, n= {2}",
					eps,Math.Abs(I1-I0),n);
			return(I1);			
		}
		private double I(double a, double b, int n, DToD sif)
		{
			//     
			double x = a, sum = sif(x)/2, dx = (b-a)/n;
			for (int i= 2; i <= n; i++)
			{
				x += dx;	sum += sif(x);
			}
			x = b; sum += sif(x)/2;
			return(sum*dx);
		}
	}//class HighOrderIntegral
	
    /// <summary>
    ///      
    /// </summary>
    class Functions
	{
		// 
		static public double sif1(double x)
		{
			int k = 1; int b = 2;
			return (double)(k*x +b);
		}
		static public double sif2(double x)
		{
			double  a = 1.0; double b = 2.0; double c= 3.0;
			return (double)(a*x*x +b*x +c);
		}
	}//class Functions
    
	/// <summary>
	/// ,      
	///   ,   
	/// </summary>
    class FIntegral
	{
		/// <summary>
		///    
		/// </summary>
		/// <param name="a">  </param>
        /// <param name="b">  </param>
		/// <param name="eps"> </param>
		/// <returns> </returns>
		public double EvaluateIntegral(double a, double b, double eps)
		{
            const int INITIAL_POINTS = 4;
            const int MAX_POINTS = 2 << 15;
            int n = INITIAL_POINTS;
			double I0=0, I1 = I( a, b, n);

            for (n *= 2; n < MAX_POINTS; n *= 2)
			{ 
				I0 =I1; I1=I(a,b,n);
				if(Math.Abs(I1-I0) < eps)break;				
			}
			if(Math.Abs(I1-I0)< eps)
				Console.WriteLine("  ! "+
					" eps = {0},   ={1}, n= {2}",
					eps,Math.Abs(I1-I0),n);
			else
				Console.WriteLine("   ! "+
					" eps = {0},   ={1}, n= {2}",
					eps,Math.Abs(I1-I0),n);
			return(I1);			
		}
		private double I(double a, double b, int n)
		{
			//     
			double x = a, sum = sif(x)/2, dx = (b-a)/n;
			for (int i= 2; i <= n; i++)
			{
				x += dx;	sum += sif(x);
			}
			x = b; sum += sif(x)/2;
			return(sum*dx);
		}
		protected virtual double sif(double x)
		{return(1.0);}
		
	}//FIntegral
	class FIntegralSon:FIntegral
	{
		protected override double sif(double x)
		{
			double  a = 1.0; double b = 2.0; double c= 3.0;
			return (double)(a*x*x +b*x +c);
		}
	}//FIntegralSon
}
