using System;
using System.Diagnostics;
using System.IO;


namespace Delegates
{
	
	public class Testing
	{
		public Testing()
		{	}
		public void TestOwnDel()
		{
			int account = 1000, account1=0;
			OwnDel oda = new OwnDel('+');
			Console.WriteLine("account = {0}, account1 = {1}",
				account, account1);
			oda.p1(ref account); account1=oda.f1(account);
			Console.WriteLine("account = {0}, account1 = {1}",
				account,
				account1);
			Person man1 = new Person("");
			MesToPers mestopers = new MesToPers(man1.ToPerson);
			Console.WriteLine(mestopers(" !"));
		}
		public  void TestEvalIntegrals()
		{			 
            HighOrderIntegral hoi = new HighOrderIntegral();
			
            DToD hoisif1 = 
				new DToD(Functions.sif1);			
			double myint1 = hoi.EvalIntegral(2,3,1e-7,hoisif1);
			Console.WriteLine("myintegral1 = {0}",myint1);

			DToD hoisif2 = 
				new DToD(Functions.sif2); 
			myint1= hoi.EvalIntegral(2,3,1e-7,hoisif2);
			Console.WriteLine("myintegral2 = {0}",myint1);
		}//EvalIntegrals
		public void TestPolymorphIntegral()
		{
			FIntegral integral1 = new FIntegral();
			FIntegralSon integral2 = new FIntegralSon();
			double res1 = integral1.EvaluateIntegral(2.0,3.0,1e-7);
			double res2 = integral2.EvaluateIntegral(2.0,3.0,1e-7);
			Console.WriteLine("Father = {0}, Son = {1}", res1, res2);
		}//PolymorphIntegral
		public void TestSortPersons()
		{
			Persons persons = new Persons(6);
			persons.LoadPersons();
			Console.WriteLine ("	  : ");
			persons.SimpleSortPerson(Person.SortByName);
			persons.PrintConsolePersons();
			Console.WriteLine ("	  : ");
			persons.SimpleSortPerson(Person.SortById);
            persons.PrintConsolePersons();
			Console.WriteLine ("	  : ");
			persons.SimpleSortPerson(Person.SortBySalary);
            persons.PrintConsolePersons();
			Console.WriteLine ("	    : ");
			persons.SimpleSortPerson(Person.SortBySalaryName);
            persons.PrintConsolePersons();
		}//SortPersons
		public void TestSomeServices()
		{
			MesToPers Comb;
			Comb = (MesToPers)Delegate.Combine(Combination.Ambulanceman,
				Combination.Policeman);
			Comb = (MesToPers)Delegate.Combine(Comb,Combination.Fireman);
			Console.WriteLine(Comb("!"));
			Comb = (MesToPers)Delegate.Remove(Comb,Combination.Fireman);
			// :      
			Comb = (MesToPers)Delegate.Remove(Comb,Combination.Special);
			Console.WriteLine(Comb(" 30 !"));
			Comb = (MesToPers)Delegate.Remove(Comb,Combination.Policeman);
			Console.WriteLine(Comb(" !"));
			Comb = (MesToPers)Delegate.Remove(Comb,Combination.Ambulanceman);
			//Console.WriteLine(Comb("  !")); // Comb  
			
            // +  -
			Comb = Combination.Ambulanceman;
			Console.WriteLine( Comb.Method.Name);
			Comb+= Combination.Fireman;
			Comb+= Combination.Policeman;
			Console.WriteLine(Comb(" !"));
			Comb -= Combination.Ambulanceman;
			Comb -= Combination.Fireman;
			Console.WriteLine(Comb("  !"));
		}//TestSomeServices
		public void TestBadService()
		{
			MesToPers Comb;
            Comb = Combination.Ambulanceman;
            Comb += Combination.Fireman;
			Comb += Combination.Special;
			Comb += Combination.Policeman;
			foreach(MesToPers currentJob in Comb.GetInvocationList())
			{
				try
				{
					Console.WriteLine(currentJob("!"));
				}
				catch(Exception e)
				{
					Console.WriteLine(e.Message);
					Console.WriteLine(currentJob.Method.Name);
				}
			}
		}//BadService
        public long Factorial(int n)
        {
            long f = 1;
            for (int i = 2; i <= n; i++)
                f = f * i;
            return f;
        }
        public long FactorialRecursive(int n)
        {
            if (n < 2) return 1;
            return FactorialRecursive(n - 1) * n;
        }
        public void TestFactorials()
        {
            for (byte n = 0; n < 15; n++)
            {
                long f1 = Factorial(n);
                long f2 = FactorialRecursive(n);
                Console.WriteLine(f1);
                Console.WriteLine(f2);
            }
        }
        public void TestAnonymous()
        {
            HighOrderIntegral integral = new HighOrderIntegral();
            double a = 0, b = Math.PI/2, eps = 1e-7;

            double result = integral.EvalIntegral(a, b, eps,
                delegate(double x) 
                { return  Math.Sin(x) + Math.Cos(x); });

            Console.WriteLine("Integral(Sin(x) + Cos(x)) " +
            "from {0} to {1} = {2} ", a, b, result.ToString());
        }
        public void TestLambda()
        {
            HighOrderIntegral integral = new HighOrderIntegral();
            double a = 0, b = Math.PI / 2, eps = 1e-7;

            double result = integral.EvalIntegral(a, b, eps,
                (double x) =>
                { return Math.Sin(x) + Math.Cos(x); });
            Console.WriteLine("Integral(Sin(x) + Cos(x)) " +
            "from {0} to {1} = {2} ", a, b, result.ToString());
        }
        class Father { }
        class Son : Father { }
        delegate string D1(string s, double x);
        delegate void D2(string s, out string s1);
        delegate string D3(Father item);
 
        public void TestAnonymToDelegate()
        {
            D1 d1 = delegate {return "OK!";};
            D1 d12 = delegate(string s, double x) { return s + x; };
            Console.WriteLine(d1("s",5));
            Console.WriteLine(d12("12", 3));
            string res;
            
            D2 d2 = delegate(string s, out string r){r = s+s;};
            d2("Hello ", out res);
            Console.WriteLine(res);
            D3 d3 = delegate(Father item) { return item.ToString(); };
            Console.WriteLine(d3(new Son()));

        }
        public void TestAnonymToLambda()
        {
            D1 d1 = (s, x) => { return "OK!"; };
            D1 d12 = (string s, double x) => { return s + x; };
            Console.WriteLine(d1("s", 5));
            Console.WriteLine(d12("12", 3));
            string res;

            D2 d2 = (string s, out string r) => { r = s + s; };
            d2("Hello ", out res);
            Console.WriteLine(res);
            D3 d3 = item => { return item.ToString(); };
            Console.WriteLine(d3(new Son()));

        }
        public void TestWithAnonymous()
        {
            WithAnonymous wan = new WithAnonymous(20,
                new double[] { 17, 23, 12, 45, 7 });
            int N;
            double res;
            wan.Traverse(10, out N, out res);
            wan.TraverseL(10, out N, out res);

            Console.WriteLine("N= {0}, res = {1}", N, res);
        }

    }
}
