﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Delegates
{
    /// <summary>
    /// Класс с анонимным методом, использующим контекст
    /// </summary>
    class WithAnonymous
    {
        double max;
        double[] array;
        public WithAnonymous(double max, double[] array)
        {
            this.max = max; this.array = array;
        }
        /// <summary>
        /// Обход массива
        /// </summary>
        /// <param name="array"> массив</param>
        /// <param name="res"> результат вычислений</param>
        /// <param name="action">действие над элементами</param>
        void Walk(double[] array, out double res, DToD action )
        {
            int current = 0; res = 0;
            while (current < array.Length)
                res += action(array[current++]);
        }
        /// <summary>
        /// Конкретизация обхода анонимным методом
        /// </summary>
        /// <param name="min">Нижняя граница отбора</param>
        /// <param name="N">Число отобранных элементов</param>
        /// <param name="res">результат обхода</param>
        public void Traverse(double min, out int N, out double res)
        {
            int n = 0;
            Walk(array, out res, delegate(double x) {
                if(x > min && x < max) {n++; return x;}
                else return 0;                      });
            N = n;
        }
        public void TraverseL(double min, out int N, out double res)
        {
            int n = 0;
            Walk(array, out res, x =>
            {
                if (x > min && x < max) { n++; return x; }
                else return 0;
            });
            N = n;
        }
    }

}
